--[[

Dear user who downloaded my mod,
if you want to use any of this code, go straight ahead, but please don't forget the license this is released with.
If you want to use the code, or an altered form of the code, in your super cool new mod, please ask me. I can be found as "DrLuke" on the DataRealms forums 
(http://www.datarealms.com/forum). If I allow you to use parts of my code, please credit me :)

Thanks for reading, 
DrLuke


P.S. Some of this code  is / may be  borrowed, all authors have been (if possible) asked and credited properly.

]]--



function randomizevinesegment(self)
	vinesegmenttable = {};
	vinesegmenttable[1] = "middle1";
	vinesegmenttable[2] = "middle2";
	vinesegmenttable[3] = "middle3";
	for i=1,50 do
		local randomnum = math.random(3)
		self.ranvine[i] = vinesegmenttable[randomnum]
	end
end

function line(self, target, seg)
	local fact = 42
	local disty = SceneMan:ShortestDistance(Vector(self.Pos.X, self.Pos.Y - fact), target.Pos, false).Y
	local distx = SceneMan:ShortestDistance(self.Pos, target.Pos, false).X
	local distance = math.sqrt(distx ^ 2 + disty ^ 2)
	local rotation = math.atan2(disty, distx)
	local parts = math.ceil(distance / seg) - 1;
	for i=0,parts do
		if i == 0 then
			segment = CreateMOSRotating("Vinestart", "Fauna.rte")
		elseif i == parts then
			segment = CreateMOSRotating("Vineend", "Fauna.rte")
		else
			segment = CreateMOSRotating(self.ranvine[i], "Fauna.rte")
		end
		segment.RotAngle = -rotation;
		segment.Pos = Vector((self.Pos.X + (math.cos(rotation) * (i * seg))), ((self.Pos.Y - fact) + (math.sin(rotation) * (i * seg))))
		MovableMan:AddParticle(segment);
	end
end



function vinemoddelta(a, rannum)
	if vinemoddeltaold == nil then
		vinemoddeltaold = {};
	end
	if vinemoddeltanew == nil then
		vinemoddeltanew = {};
	end
	vinemoddeltaold[rannum] = vinemoddeltanew[rannum]
	vinemoddeltanew[rannum] = a
	if vinemoddeltanew[rannum] ~= nil and vinemoddeltaold[rannum] ~= nil then
		return (vinemoddeltanew[rannum] - vinemoddeltaold[rannum])
	end
end


local count = 0;

function slowdown(self)
	if self.slow == 1 then
		if self.count == nil then
			self.count = 0;
		else
			self.count = self.count + 1
		end
		if self.target.Vel.X >= 15 then
			self.target.Vel.X = self.target.Vel.X - 15;
		else
			self.target.Vel.X = 0;
			self.slow = 0;
			self.count = 0;
		end
	end
	if self.count == 5 then
		self.slow = 0;
	end
end

local hcount = 0;

function Pull(Object, self, mag, mode)
	local disty = SceneMan:ShortestDistance(Vector(self.Pos.X, self.Pos.Y - 46), Object.Pos, false).Y
	local distx = SceneMan:ShortestDistance(self.Pos, Object.Pos, false).X
	local rotation = math.atan2(disty, distx)
	if mode == 0 then
		Object:AddImpulseForce(Vector(-(math.cos(rotation) * mag), -(math.sin(rotation) * mag)), Vector(0, 0))
	else
		Object:AddImpulseForce(Vector(0, 100), Vector(0, 0))
		hcount = hcount + 1
		if hcount == 5 then
			hcount = 0
			Object.Health = Object.Health - 1;
		end
	end
	if vinemoddelta(mode, self.number) ~= nil then
		if vinemoddelta(mode, self.number) > 0 then
			self.slow = 1;
		end
	end
end

local xtru = 0;
local ytru = 0;

function inbox(target, x1, x2, y1, y2)
	if target.Pos.X > x1 and target.Pos.X < x2 then
		xtru = 1
	else
		xtru = 0;
	end
	if target.Pos.Y > y1 and target.Pos.Y < y2 then
		ytru = 1
	else
		ytru = 0;
	end
	if xtru == 1 and ytru == 1 then
		return true
	else
		return false
	end
end

function killvinetablea()
	for i=-20,20 do
		local absi = math.abs(i);
		killvinetable[i] = -math.floor((absi/40)^2 * 30);
	end
end

local kcount = 0;
function kill(self, int)
	kcount = kcount + 1;
	if kcount == int then
		kcount = 0;
		local kill = CreateMOPixel("vinekiller", "Fauna.rte");
		local xrand = math.random(-20,20);
		kill.Pos.X = xrand + self.Pos.X
		kill.Pos.Y = killvinetable[xrand] + self.Pos.Y + 20
		MovableMan:AddParticle(kill);
	end
end
		

function Create(self)
	if globalvinenumber == nil then
		globalvinenumber = 1;
		self.number = globalvinenumber;
	else
		globalvinenumber = globalvinenumber + 1;
		self.number = globalvinenumber;
	end
	self.ranvine = {};
	self.targeta = 0;
	randomizevinesegment(self)
	if killvinetable == nil then
		killvinetable = {};
		killvinetablea()
	end
end

function Update(self)
	if self.targeta == 0 then
		for actor in MovableMan.Actors do
			if (actor.Pos - self.Pos).Magnitude < 200 then
				if actor.targetted == 1 then
					self.targeta = 0;
					break
				end
				self.target = actor;
				self.targeta = 1;
				self.target.targetted = 1;
			end
		end
	end
	if self.targeta == 1 then
		if MovableMan:ValidMO(MovableMan:GetMOFromID(self.target.RootID)) then
			line(self, self.target, 9)
			if inbox(self.target, (self.Pos.X - 15), (self.Pos.X + 15), (self.Pos.Y - 60), (self.Pos.Y + 50)) == true then -- fix, make it box-ish
				Pull(self.target, self, 2, 1)
				slowdown(self)
			else
				Pull(self.target, self, (math.max(math.min(500, (self.target.Mass * 3.5)), 100)), 0)
			end
		end
		if self.target.Health <= 0 or self.target:IsSetToDelete() or (self.target.Pos - self.Pos).Magnitude > 350 then
			self.target.targetted = 0;
			self.targeta = 0;
		end
	else
		local piece = CreateMOSRotating("Vinestart", "Fauna.rte")
		piece.Pos = Vector(self.Pos.X, self.Pos.Y - 42);
		piece.RotAngle = 1;
		MovableMan:AddParticle(piece)
	end
	kill(self, 5) --No, this isn't meant to kill it"self", but it's used for passing the pit's position in a rather decent way (As opposed to transfer X and Y values seperately)
end

	